﻿using System;

namespace TestProject
{
    /// <summary>
    /// 프로그램
    /// </summary>
    class Program
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Enumeration
        ////////////////////////////////////////////////////////////////////////////////////////// Private

        #region 색상 타입 - ColorType

        /// <summary>
        /// 색상 타입
        /// </summary>
        private enum ColorType
        {
            /// <summary>
            /// 적색
            /// </summary>
            Red,

            /// <summary>
            /// 녹색
            /// </summary>
            Green,

            /// <summary>
            /// 청색
            /// </summary>
            Blue
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Method
        ////////////////////////////////////////////////////////////////////////////////////////// Static
        //////////////////////////////////////////////////////////////////////////////// Private

        #region 프로그램 시작하기 - Main()

        /// <summary>
        /// 프로그램 시작하기
        /// </summary>
        private static void Main()
        {
            Console.Title = "Enum 클래스 : IsDefined 정적 메소드를 사용해 정의된 열거형 값 여부 구하기";

            Console.WriteLine($"0       : {IsColorType(0)        }");
            Console.WriteLine($"1       : {IsColorType(1)        }");
            Console.WriteLine($"2       : {IsColorType(2)        }");
            Console.WriteLine($"3       : {IsColorType(3)        }");
            Console.WriteLine($"Red     : {IsColorType("Red")    }");
            Console.WriteLine($"RED     : {IsColorType("RED")    }");
            Console.WriteLine($"red     : {IsColorType("red")    }");
            Console.WriteLine($"Magenta : {IsColorType("Magenta")}");
        }

        #endregion
        #region 색상 타입 여부 구하기 - IsColorType(value)

        /// <summary>
        /// 색상 타입 여부 구하기
        /// </summary>
        /// <param name="value">값</param>
        /// <returns>색상 타입 여부</returns>
        private static bool IsColorType(object value)
        {
            return Enum.IsDefined(typeof(ColorType), value);
        }

        #endregion
    }
}